xfstests: rename USE_BIG_LOOPFS to be more generic
[xfstests-dev.git] / 148
1 #! /bin/bash
2 # FS QA Test No. 148
3 #
4 # Exercise xfs parallel repair on broken filesystems
5 # This is a clone of test 030 useing xfs_prepair64 instead of xfs_repair
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2006 Silicon Graphics, Inc.  All Rights Reserved.
9 #
10 # This program is free software; you can redistribute it and/or
11 # modify it under the terms of the GNU General Public License as
12 # published by the Free Software Foundation.
13 #
14 # This program is distributed in the hope that it would be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 # GNU General Public License for more details.
18 #
19 # You should have received a copy of the GNU General Public License
20 # along with this program; if not, write the Free Software Foundation,
21 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
22 #
23 #-----------------------------------------------------------------------
24 #
25 # creator
26 owner=ddiss@sgi.com
27
28 seq=`basename $0`
29 echo "QA output created by $seq"
30
31 here=`pwd`
32 tmp=/tmp/$$
33 status=1        # failure is the default!
34
35 _cleanup()
36 {
37         cd /
38         umount $SCRATCH_DEV 2>/dev/null
39         rm -f $tmp.*
40 }
41
42 trap "_cleanup; exit \$status" 0 1 2 3 15
43
44 # get standard environment, filters and checks
45 . ./common.rc
46 . ./common.filter
47 . ./common.repair
48
49 [ -z "$XFS_PARALLEL_REPAIR64_PROG" ] && _notrun "parallel repair binary xfs_prepair64 is not installed"
50
51 # force use of parallel repair
52 export XFS_REPAIR_PROG=$XFS_PARALLEL_REPAIR64_PROG
53
54 # nuke the superblock, AGI, AGF, AGFL; then try repair the damage
55
56 _check_ag()
57 {
58         for structure in 'sb 0' 'agf 0' 'agi 0' 'agfl 0'
59         do
60                 echo "Corrupting $structure - setting bits to $1"
61                 _check_repair $1 "$structure"
62         done
63 }
64
65 # real QA test starts here
66 _supported_fs xfs
67 _supported_os IRIX Linux
68
69 _require_scratch
70 _require_no_large_scratch_dev
71
72 DSIZE="-dsize=100m"
73
74 # first we need to ensure there are no bogus secondary
75 # superblocks between the primary and first secondary
76 # superblock (hanging around from earlier tests)...
77 #
78
79 _scratch_mkfs_xfs $DSIZE >/dev/null 2>&1
80 if [ $? -ne 0 ]         # probably don't have a big enough scratch
81 then
82         _notrun "SCRATCH_DEV too small, results would be non-deterministic"
83 else
84         _scratch_mount
85         src/feature -U $SCRATCH_DEV && \
86                 _notrun "UQuota are enabled, test needs controlled sb recovery"
87         src/feature -G $SCRATCH_DEV && \
88                 _notrun "GQuota are enabled, test needs controlled sb recovery"
89         src/feature -P $SCRATCH_DEV && \
90                 _notrun "PQuota are enabled, test needs controlled sb recovery"
91         umount $SCRATCH_DEV
92 fi
93 clear=""
94 eval `xfs_db -r -c "sb 1" -c stack $SCRATCH_DEV | $PERL_PROG -ne '
95         if (/byte offset (\d+), length (\d+)/) {
96                 print "clear=", $1 / 512, "\n"; exit
97         }'`
98 [ -z "$clear" ] && echo "Cannot calculate length to clear"
99 src/devzero -v -1 -n "$clear" $SCRATCH_DEV >/dev/null
100
101 # now kick off the real prepair test...
102 #
103 _scratch_mkfs_xfs $DSIZE | _filter_mkfs 2>$tmp.mkfs
104 . $tmp.mkfs
105 _check_ag 0
106 _check_ag -1
107
108
109 # success, all done
110 status=0
111 exit